module.exports = {
	plugins: [
		'stylelint-scss',
		'stylelint-order',
	],
	rules: {
		'scss/dollar-variable-empty-line-before': ['always', {
			except: ['first-nested', 'after-comment', 'after-dollar-variable'],
		}],
		'scss/dollar-variable-colon-newline-after': 'always-multi-line',
		'scss/dollar-variable-colon-space-after': 'always-single-line',
		'scss/dollar-variable-colon-space-before': 'never',

		'order/order': [
			'dollar-variables',
			'at-rules',
			'declarations',
			{
				type: 'at-rule',
				name: 'keyframes',
			},
			{
				type: 'at-rule',
				name: 'media',
			},
			// {
			// 	type: 'rule',
			// 	selector: '^&:(hover|focus|active)$',
			// },
			// {
			// 	type: 'rule',
			// 	selector: '^&--[\\w-]+$',
			// 	description: 'BEM modifiers, e. g. &--wide',
			// },
			// {
			// 	type: 'rule',
			// 	selector: '^&\\.[\\w-]+$',
			// 	description: 'E. g. &.is-open',
			// },
			// {
			// 	type: 'rule',
			// 	selector: '^&\\[.+\\]$',
			// 	description: 'E. g. &[disabled]',
			// },
			// {
			// 	type: 'rule',
			// 	selector: '^&:(before|after)$',
			// },
			// {
			// 	type: 'rule',
			// 	selector: '^&::\\w+$',
			// 	description: 'Pseudo-elements',
			// },
			'rules',
		],
		'order/properties-order': [
			[
				'lost-utility',
				'lost-flex-container',
				'lost-center',
				'lost-align',
				'lost-column',
				'lost-row',
				'lost-waffle',
				'lost-offset',
				'lost-move',
				'lost-masonry-wrap',
				'lost-masonry-column',
				'position',
				'top',
				'right',
				'bottom',
				'left',
				'z-index',
				'display',
				'visibility',
				'flex',
				'flex-grow',
				'flex-shrink',
				'flex-basis',
				'flex-direction',
				'flex-flow',
				'flex-wrap',
				'align-content',
				'align-items',
				'align-self',
				'justify-content',
				'order',
				'float',
				'clear',
				'overflow',
				'overflow-x',
				'overflow-y',
				'overflow-scrolling',
				'clip',
				'box-sizing',
				'margin',
				'margin-top',
				'margin-right',
				'margin-bottom',
				'margin-left',
				'padding',
				'padding-top',
				'padding-right',
				'padding-bottom',
				'padding-left',
				'min-width',
				'min-height',
				'max-width',
				'max-height',
				'width',
				'height',
				'outline',
				'outline-width',
				'outline-style',
				'outline-color',
				'outline-offset',
				'border',
				'border-spacing',
				'border-collapse',
				'border-width',
				'border-style',
				'border-color',
				'border-top',
				'border-top-width',
				'border-top-style',
				'border-top-color',
				'border-right',
				'border-right-width',
				'border-right-style',
				'border-right-color',
				'border-bottom',
				'border-bottom-width',
				'border-bottom-style',
				'border-bottom-color',
				'border-left',
				'border-left-width',
				'border-left-style',
				'border-left-color',
				'border-radius',
				'border-top-left-radius',
				'border-top-right-radius',
				'border-bottom-right-radius',
				'border-bottom-left-radius',
				'border-image',
				'border-image-source',
				'border-image-slice',
				'border-image-width',
				'border-image-outset',
				'border-image-repeat',
				'border-top-image',
				'border-right-image',
				'border-bottom-image',
				'border-left-image',
				'border-corner-image',
				'border-top-left-image',
				'border-top-right-image',
				'border-bottom-right-image',
				'border-bottom-left-image',
				'background',
				'background-color',
				'background-image',
				'background-attachment',
				'background-position',
				'background-position-x',
				'background-position-y',
				'background-clip',
				'background-origin',
				'background-size',
				'background-repeat',
				'box-decoration-break',
				'box-shadow',
				'color',
				'table-layout',
				'caption-side',
				'empty-cells',
				'list-style',
				'list-style-position',
				'list-style-type',
				'list-style-image',
				'quotes',
				'content',
				'counter-increment',
				'counter-reset',
				'-ms-writing-mode',
				'vertical-align',
				'text-align',
				'text-align-last',
				'text-decoration',
				'text-emphasis',
				'text-emphasis-position',
				'text-emphasis-style',
				'text-emphasis-color',
				'text-indent',
				'text-justify',
				'text-outline',
				'text-transform',
				'text-wrap',
				'text-overflow',
				'text-overflow-ellipsis',
				'text-overflow-mode',
				'text-shadow',
				'white-space',
				'word-spacing',
				'word-wrap',
				'word-break',
				'overflow-wrap',
				'tab-size',
				'hyphens',
				'letter-spacing',
				'font',
				'font-weight',
				'font-style',
				'font-variant',
				'font-size-adjust',
				'font-stretch',
				'font-size',
				'font-family',
				'src',
				'line-height',
				'interpolation-mode',
				'opacity',
				'filter',
				'resize',
				'cursor',
				'nav-index',
				'nav-up',
				'nav-right',
				'nav-down',
				'nav-left',
				'transition',
				'transition-delay',
				'transition-timing-function',
				'transition-duration',
				'transition-property',
				'transform',
				'transform-origin',
				'animation',
				'animation-name',
				'animation-duration',
				'animation-play-state',
				'animation-timing-function',
				'animation-delay',
				'animation-iteration-count',
				'animation-direction',
				'animation-fill-mode',
				'pointer-events',
				'unicode-bidi',
				'direction',
				'columns',
				'column-span',
				'column-width',
				'column-count',
				'column-fill',
				'column-gap',
				'column-rule',
				'column-rule-width',
				'column-rule-style',
				'column-rule-color',
				'break-before',
				'break-inside',
				'break-after',
				'page-break-before',
				'page-break-inside',
				'page-break-after',
				'orphans',
				'widows',
				'zoom',
				'max-zoom',
				'min-zoom',
				'user-zoom',
				'orientation',
				'user-select',
				'fill',
				'stroke',
			],
			{
				unspecified: 'bottom',
			},
		],

		'color-hex-case': 'lower',
		'color-hex-length': 'short',
		'color-no-invalid-hex': true,

		'font-family-name-quotes': 'always-unless-keyword',

		'function-calc-no-unspaced-operator': true,
		'function-comma-newline-after': 'always-multi-line',
		'function-comma-newline-before': 'never-multi-line',
		'function-comma-space-after': 'always-single-line',
		'function-comma-space-before': 'never',
		'function-linear-gradient-no-nonstandard-direction': true,
		'function-parentheses-newline-inside': 'always-multi-line',
		'function-parentheses-space-inside': 'never',
		'function-url-no-scheme-relative': true,
		'function-url-quotes': 'always',
		'function-whitespace-after': 'always',

		'number-leading-zero': 'never',
		'number-no-trailing-zeros': true,

		'string-no-newline': true,
		'string-quotes': 'double',

		'length-zero-no-unit': true,

		'unit-case': 'lower',
		'unit-no-unknown': true,

		'value-keyword-case': 'lower',
		'value-no-vendor-prefix': true,

		'value-list-comma-newline-after': 'always-multi-line',
		'value-list-comma-newline-before': 'never-multi-line',
		'value-list-comma-space-after': 'always-single-line',
		'value-list-comma-space-before': 'never',

		'shorthand-property-no-redundant-values': true,

		'property-case': 'lower',
		'property-no-vendor-prefix': true,

		'keyframe-declaration-no-important': true,

		'declaration-bang-space-after': 'never',
		'declaration-bang-space-before': 'always',
		'declaration-colon-newline-after': 'always-multi-line',
		'declaration-colon-space-after': 'always-single-line',
		'declaration-colon-space-before': 'never',
		'declaration-empty-line-before': ['always', {
			except: ['first-nested', 'after-comment', 'after-declaration'],
		}],
		'declaration-no-important': [true, {
			severity: 'warning',
		}],

		'declaration-block-no-duplicate-properties': [true, {
			ignore: ['consecutive-duplicates'],
		}],
		'declaration-block-no-shorthand-property-overrides': true,
		'declaration-block-semicolon-newline-after': 'always',
		'declaration-block-semicolon-newline-before': 'never-multi-line',
		'declaration-block-semicolon-space-after': 'always-single-line',
		'declaration-block-semicolon-space-before': 'never',
		'declaration-block-trailing-semicolon': 'always',

		'block-closing-brace-empty-line-before': 'never',
		'block-closing-brace-newline-after': 'always',
		'block-closing-brace-newline-before': 'always',
		'block-opening-brace-newline-after': 'always',
		'block-opening-brace-space-before': 'always',

		'selector-attribute-brackets-space-inside': 'never',
		'selector-attribute-operator-space-after': 'never',
		'selector-attribute-operator-space-before': 'never',
		'selector-attribute-quotes': 'always',
		'selector-combinator-space-after': 'always',
		'selector-combinator-space-before': 'always',
		'selector-max-empty-lines': 0,
		'selector-max-id': 0,
		'selector-max-universal': 0,
		'selector-no-vendor-prefix': true,
		'selector-pseudo-class-case': 'lower',
		'selector-pseudo-class-no-unknown': true,
		'selector-pseudo-class-parentheses-space-inside': 'never',
		'selector-pseudo-element-case': 'lower',
		'selector-pseudo-element-no-unknown': true,
		'selector-type-case': 'lower',
		'selector-type-no-unknown': true,

		'selector-list-comma-newline-after': 'always',
		'selector-list-comma-newline-before': 'never-multi-line',
		'selector-list-comma-space-after': 'always-single-line',
		'selector-list-comma-space-before': 'never',

		'rule-empty-line-before': ['always', {
			except: ['first-nested', 'after-rule'],
			ignore: ['after-comment'],
		}],

		'media-feature-colon-space-after': 'always',
		'media-feature-colon-space-before': 'never',
		'media-feature-parentheses-space-inside': 'never',
		'media-feature-range-operator-space-after': 'always',
		'media-feature-range-operator-space-before': 'always',

		'media-query-list-comma-newline-after': 'always-multi-line',
		'media-query-list-comma-newline-before': 'never-multi-line',
		'media-query-list-comma-space-after': 'always-single-line',
		'media-query-list-comma-space-before': 'never',

		'at-rule-empty-line-before': ['always', {
			except: ['after-same-name', 'first-nested'],
			ignore: ['after-comment'],
		}],
		'at-rule-name-case': 'lower',
		'at-rule-no-vendor-prefix': true,
		'at-rule-name-space-after': 'always',
		'at-rule-semicolon-newline-after': 'always',
		'at-rule-semicolon-space-before': 'never',

		'comment-whitespace-inside': 'always',

		'indentation': 'tab',
		'max-empty-lines': 1,
		'no-duplicate-selectors': true,
		'no-eol-whitespace': true,
		'no-extra-semicolons': true,
		'no-missing-end-of-source-newline': true,
		'no-unknown-animations': true,
	},
};
